import calendar
import datetime
import time

from dateutil.relativedelta import relativedelta

cWochentageL = ("Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Samstag", "Sonntag")
cMonateL = (
    "Januar", "Februar", "März", "April", "Mai", "Juni", "Juli", "August", "September", "Oktober", "November",
    "Dezember")

# Bundesländer

cSN = 'SN'
cBY = 'BY'
cSH = 'SH'
cBE = 'BE'
cMV = 'MV'
cBB = 'BB'
cST = 'ST'
cTH = 'TH'
cHH = 'HH'
cHB = 'HB'
cNW = 'NW'
cHS = 'HS'
cBW = 'BW'
cRP = 'RP'
cSL = 'SL'

cTerminWiederH_0_Keine = 0
cTerminWiederH_1_woechentlich = 1
cTerminWiederH_2_14_taegig = 2
cTerminWiederH_3_monatlich = 3
cTerminWiederH_4_zwei_monatlich = 4
cTerminWiederH_5_drei_monatlich = 5
cTerminWiederH_6_halb_jaehrlich = 6
cTerminWiederH_7_jaehrlich = 7
cTerminWiederH_8_drei_woechig = 8

cJahrLaenge = 365.2425
cSommeranfang2019 = datetime.datetime(2019, 6, 21, 17, 54)  # 21. Juni 2019 17:54 Uhr MESZ


def wnfJahrLaenge():
    dt = datetime.timedelta(cJahrLaenge)
    return dt


def wnfSommerAnfang(dt):
    xx = cSommeranfang2019
    while xx < dt:
        xx = xx + datetime.timedelta(cJahrLaenge)
        if isSchaltjahrJJ(dt.year):
            xx = xx - datetime.timedelta(0)
    return xx


def wnfWinterAnfang(dt):
    dt = wnfSommerAnfang(dt)
    dt = dt + datetime.timedelta(cJahrLaenge / 2)
    return dt


def wnfHerbstAnfang(dt):
    dt = wnfSommerAnfang(dt)
    dt = dt + datetime.timedelta(cJahrLaenge / 4)
    return dt


def wnfFruehlingsAnfang(dt):
    dt = wnfSommerAnfang(dt)
    dt = dt - datetime.timedelta(cJahrLaenge / 4)
    return dt


def wnfGegentag(dt):
    aa = wnfSommerAnfang(dt)
    xx = aa - dt
    zz = aa + xx
    return zz


def wnfHeute():
    return datetime.date.today()


def wnfJetzt():
    return datetime.datetime.now()

def wnfJetztAsString():
    return datetime.datetime.now().strftime('%d.%m.%Y %H:%M:%S')

def wochentag_i(d):
    w = calendar.weekday(d.year, d.month, d.day)
    return w


def diesesJahr(d):
    d = d.replace(year=datetime.date.today().year)
    return d


def naechstesJahr(d):
    d = d.replace(year=datetime.date.today().year + 1)
    return d


def alterInJahren(d1, d2):
    return relativedelta(d2, d1).years


def ersterDieserWoche(d):
    w = calendar.weekday(d.year, d.month, d.day)
    d = d + datetime.timedelta(days=-w)
    # print w, d
    return d


def ersterDieserMonat(d):
    d = d.replace(day=1)
    return d


def monatsLaenge(d):
    return calendar.monthrange(d.year, d.month)[1]


def letzterDieserMonat(d):
    d = ersterDieserMonat(d) + datetime.timedelta(days=monatsLaenge(d) - 1)
    return d


def ersterNaechsterMonat(d):
    d = d.replace(day=1)
    try:
        d = d.replace(month=d.month + 1)
    except ValueError:
        if d.month == 12:
            d = d.replace(year=d.year + 1, month=1)
        else:
            # next month is too short to have "same date"
            # pick your own heuristic, or re-raise the exception:
            raise
    return d


def ersterVorMonat(d):
    d = d.replace(day=1)
    try:
        d = d.replace(month=d.month - 1)
    except ValueError:
        if d.month == 1:
            d = d.replace(year=d.year - 1, month=12)
        else:
            # next month is too short to have "same date"
            # pick your own heuristic, or re-raise the exception:
            raise
    return d

def ersterDiesesJahr(d):
    d = d.replace(day=1)
    d = d.replace(month=1)
    return d

def letzterDiesesJahr(d):
    d = d.replace(day=31)
    d = d.replace(month=12)
    return d

def ersterNaechstesJahr(d):
    d = d.replace(day=1)
    d = d.replace(month=1)
    d = d.replace(year=d.year+1)
    return d

def ersterVorJahr(d):
    d = d.replace(day=1)
    d = d.replace(month=1)
    d = d.replace(year=d.year-1)
    return d

def incMonth(sourcedate, months):
    month = sourcedate.month - 1 + months
    year = sourcedate.year + month // 12
    month = month % 12 + 1
    day = min(sourcedate.day, calendar.monthrange(year, month)[1])
    return datetime.date(year, month, day)


def dateToStr(d):
    return d.strftime("%d.%m.%Y")


def dateToMMTTYYYY(d):
    return d.strftime("%m%d%Y")


def MMTTYYYYtoDate(s):
    try:
        return datetime.date(*time.strptime(s, "%m%d%Y")[0:3])
    except:
        return None


def YYYYtoDate(s):
    try:
        return datetime.date(*time.strptime(s, "%Y")[0:3])
    except:
        return None


def YYYYMMtoDate(s):
    try:
        return datetime.date(*time.strptime(s, "%Y%m")[0:3])
    except:
        return None


def YYYY_MM_TT_to_TT_MM_YYYY(s):
    return "%s.%s.%s" % (s[8:10], s[5:7], s[0:4])


def TT_MM_YYYY_ToDate(s):
    try:
        return datetime.date(*time.strptime(s, "%Y-%m-%d")[0:3])
    except:
        return wnfHeute()


def strToDate(s):
    try:
        return datetime.date(*time.strptime(s, "%d.%m.%Y")[0:3])
    except:
        return wnfHeute()


def strToDateTime(s):
    try:
        return datetime.datetime(*time.strptime(s, "%d.%m.%Y")[0:3])
    except:
        return wnfJetzt()


def isSchaltjahrJJ(jj):
    if (jj % 400) == 0:
        return True
    elif (jj % 100) == 0:
        return False
    elif (jj % 4) == 0:
        return True
    return False


def isSchaltjahr(d):
    jj = d.year
    return isSchaltjahr(jj)


def isSonntag(d):
    return d.weekday() == 6


# Datum des Ostersonntags
def ostersonntag(jahr):
    A = jahr % 19
    K = jahr // 100
    M = 15 + (3 * K + 3) // 4 - (8 * K + 13) // 25
    D = (19 * A + M) % 30
    S = 2 - (3 * K + 3) // 4
    R = D // 29 + (D // 28 - D // 29) * (A // 11)
    OG = 21 + D + R
    SZ = 7 - (jahr + jahr // 4 + S) % 7
    OE = 7 - (OG - SZ) % 7
    OS = (OG + OE)
    if OS > 31:
        return (jahr, 4, OS - 31)
    else:
        return (jahr, 3, OS)


# Tagesnummer des Datums
def tagesnummer(jj, mm, tt):
    tn = 0
    if mm > 1:
        tn = tn + 31
    if mm > 2:
        tn = tn + 28
    if mm > 3:
        tn = tn + 31
    if mm > 4:
        tn = tn + 30
    if mm > 5:
        tn = tn + 31
    if mm > 6:
        tn = tn + 30
    if mm > 7:
        tn = tn + 31
    if mm > 8:
        tn = tn + 31
    if mm > 9:
        tn = tn + 30
    if mm > 10:
        tn = tn + 31
    if mm > 11:
        tn = tn + 30
    tn = tn + tt
    if isSchaltjahrJJ(jj) and (mm > 2):
        tn = tn + 1
    return tn


# Tagesnummer des Ostersonntags
def ostersonntag_tn(jahr):
    jj, mm, tt = ostersonntag(jahr)
    tn = tagesnummer(jj, mm, tt)
    return (tn)


def sFeiertag(d, aBundesland):
    """Liefert die Bezeichnung des Feiertags oder einen Leerstring"""
    jj = d.year
    mm = d.month
    tt = d.day
    os = ostersonntag_tn(jj)
    tn = tagesnummer(jj, mm, tt)
    s = ""
    if tn == os:
        s = "Ostersonntag"
    elif tn == os + 1:
        s = "Ostermontag"
    elif tn == os - 2:
        s = "Karfreitag"
    elif tn == os + 39:
        s = 'Himmelfahrt'
    elif tn == os + 49:
        s = "Pfingstsonntag";
    elif tn == os + 50:
        s = "Pfingstmontag"
    elif (tn == os + 60) and (aBundesland in [cBW, cBY, cHS, cNW, cRP, cSL]):
        s = "Fronleichnam"
    elif (mm == 1) and (tt == 1):
        s = "Neujahr"
    elif (mm == 5) and (tt == 1):
        s = "Maifeiertag"
    elif (mm == 10) and (tt == 3):
        s = "Tag der Einheit"
    elif (mm == 12) and (tt == 25):
        s = "Weihnachten"
    elif (mm == 12) and (tt == 26):
        s = "Weihnachten"
    elif (mm == 1) and (tt == 6) and (aBundesland in [cBW, cBY, cST]):
        s = u"Heilige Drei Könige"
    elif (mm == 8) and (tt == 15) and (aBundesland in [cBY, cSL]):
        s = "Mariä Aufnahme"
    elif (mm == 10) and (tt == 31) and (aBundesland in [cBB, cMV, cSN, cST, cTH]):
        s = "Reformationstag"
    elif (mm == 11) and (tt == 1) and (aBundesland in [cBW, cBY, cNW, cRP, cSL]):
        s = "Allerheiligen"
    elif (mm == 11) and (aBundesland in [cSN]):
        # Wikipedia.de   Im 20. Jahrhundert wurde der Buß und Bettag meist
        # am Mittwoch vor dem Ewigkeitssonntag
        # (der letzte Sonntag des Kirchenjahres) begangen,
        # also am Mittwoch vor dem 23. November bzw. 11 Tage vor dem ersten Adventssonntag.
        # Die Termine des Buß- und Bettages bis 2010 sind:
        # 16.11.2005, 22.11.2006, 21.11.2007, 19.11.2008, 18.11.2009 und 17.11.2010.
        dx = datetime.date(jj, mm, 23 - 1)
        # den Mittwoch vor dem 23.11. suchen
        while dx.weekday() != 2:
            dx = dx + datetime.timedelta(days=-1)
        if (tt == dx.day):
            s = u"Buß-und Bettag"

    return (s)


if __name__ == '__main__':
    dt = wnfJetzt()
    print(wnfSommerAnfang(dt))
    print(wnfWinterAnfang(dt))
    print(wnfFruehlingsAnfang(dt))
    print(wnfHerbstAnfang(dt))
    print('Gegentag %s' % wnfGegentag(dt))
    print(ostersonntag(dt.year))
