import sys
from PyQt5 import QtGui, QtWidgets
import nfix_const as C
import nfix_tools as T
import nfix_desktopkalender as DK

MODULNAME = 'Einstellungen'


class Ui_Dialog(object):
    def setupUi(self, Dialog):
        self.setWindowTitle("%s %s" % (MODULNAME,DK.cCaption))
        self.setMinimumWidth(600)
        layout_grid = QtWidgets.QGridLayout(self)
        items = []
        self.addBB(items, 'Desktopkalender', Dialog.starteDesktopkalender)
        self.addBB(items, 'Desktopkalender Oben Links', Dialog.starteDesktopkalender_OL)
        self.addBB(items, 'Desktopkalender Oben Rechts', Dialog.starteDesktopkalender_OR)
        self.addBB(items, 'Desktopkalender Unten Links', Dialog.starteDesktopkalender_UL)
        self.addBB(items, 'Desktopkalender Unten Rechts', Dialog.starteDesktopkalender_UR)
        self.addBB(items, 'Desktopkalender GwenView', Dialog.starteDesktopkalender_GwenView)
        self.addBB(items, 'Desktopkalender Edit Ini-Datei', Dialog.starteDesktopkalender_EditIni)
        for item in items:
            layout_grid.addWidget(item)

    def addBB(self, aItems, aCaption, aAction):
        bb = QtWidgets.QPushButton(aCaption)
        bb.clicked.connect(aAction)
        aItems.append(bb)
        return bb


class Dialog(QtWidgets.QDialog, Ui_Dialog):
    def __init__(self, parent=None):
        QtWidgets.QDialog.__init__(self, parent)
        self.setupUi(self)

    def starteDesktopkalender(self):
        DK.refreshDesktopkalender()

    def starteDesktopkalender_OL(self):
        DK.ausrichtungDesktopkalender('OL')

    def starteDesktopkalender_OR(self):
        DK.ausrichtungDesktopkalender('OR')

    def starteDesktopkalender_UL(self):
        DK.ausrichtungDesktopkalender('UL')

    def starteDesktopkalender_UR(self):
        DK.ausrichtungDesktopkalender('UR')

    def starteDesktopkalender_GwenView(self):
        DK.gwenviewDesktopkalender()

    def starteDesktopkalender_EditIni(self):
        aIniDateiname = T.getHomeDirConfigWlsoft(T.cWnfDesktopKalenderIni)
        T.kate(aIniDateiname)

    def anzeigen(self):
        # modal ausführen
        self.exec_()


def main():
    app = QtWidgets.QApplication(sys.argv)
    app.setApplicationName(C.PROGNAME)
    #
    app.mainwindow = Dialog()
    #
    app.setWindowIcon(QtGui.QIcon('nfix.png'))
    app.mainwindow.anzeigen()
    # sys.exit(app.exec_())
    return 0


if __name__ == '__main__':
    main()
